"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _fEngine = require("@antv/f-engine");
var _gLottiePlayer = require("@antv/g-lottie-player");
var Lottie = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(Lottie, _Component);
  var _super = (0, _createSuper2.default)(Lottie);
  function Lottie(props) {
    var _this;
    (0, _classCallCheck2.default)(this, Lottie);
    _this = _super.call(this, props);
    _this.updateSize = function () {
      var _this$size = _this.size,
        currentWidth = _this$size.width,
        currentHeight = _this$size.height;
      var style = _this.props.style;
      if (!style) return;
      var _style$width = style.width,
        width = _style$width === void 0 ? currentWidth : _style$width,
        _style$height = style.height,
        height = _style$height === void 0 ? currentHeight : _style$height;
      _this.ref.current.scale(width / currentWidth, height / currentHeight);
      _this.size = {
        width: width,
        height: height
      };
    };
    _this.ref = (0, _fEngine.createRef)();
    return _this;
  }
  (0, _createClass2.default)(Lottie, [{
    key: "didMount",
    value: function didMount() {
      var _this2 = this;
      var props = this.props,
        context = this.context;
      var data = props.data,
        options = props.options;
      var canvas = context.canvas;
      // 文档流后挂载lottie
      canvas.ready.then(function () {
        var animation = (0, _gLottiePlayer.loadAnimation)(data, options);
        animation.render(_this2.ref.current);
        _this2.size = animation.size();
        _this2.updateSize();
      });
    }
  }, {
    key: "willUpdate",
    value: function willUpdate() {
      var _this3 = this;
      var context = this.context;
      var canvas = context.canvas;
      canvas.ready.then(function () {
        _this3.updateSize();
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        style = _this$props.style,
        animation = _this$props.animation;
      return (0, _fEngine.jsx)("group", {
        ref: this.ref,
        style: style,
        animation: animation
      });
    }
  }]);
  return Lottie;
}(_fEngine.Component);
var _default = Lottie;
exports.default = _default;